	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.15.05
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'P:\SHDesigns\SofTools\BB_RAM\sample\bb_test.c' 16 21 21 23 5 26
;1 /*
;2   bb_test.c byt SHDesigns http://shdesigns.org/tips/
;3 
;4   This sample uses bb_ram.lib to allocate a battery-backed near RAM segment
;5 
;6   For boards with FAST RAM (RCM32xx, RCM33xx, RCM38xx), define FAST_RAM as 
;7   For boards without the FAST RAM define FAST_RAM as 0
;8 
;9   set up the linker with
;10 
;11   BB_BSS	- before BSS, set tp "Precede following segment",
;12   				 type Data, alignment 1000
;13   BSS		- change alignment to 1000
;14   BSSZ 		- unchanged
;15   IDATA		- unchanged
;16   STACK		- unchanged
;17 
;18   Note: if you do not have Fast RAM, you will not need the alignment,
;19    leave it blank to save near space.
;20 
;21   Add bb_ram.lib to the link Lib and obj list.
;22 
;23   The BB_BSS seg is forced to a multiple of 4096. You can minimize near
;24   wasted space by making it as close to a multiple of 4096.
;25 
;26   This sample uses a BB_KEY to test if memory is valid. An option may
;27   be to use CRC on critical data to detect for corruction. A "key"
;28   variable is usually good enough.
;29 
;30   Notes:
;31 	This test changes BBRAM to use 4 wait states. This is only
;32 	to verify the RAM is actually being used. Speed tests will show
;33 	the difference in speed if the mapping is correct. On boards without
;34 	FAST RAM, ther is no difference.
;35 
;36 	There is one reason to use the map_bbram() on boards without fast RAM:
;37 	the battery-backed variables will be put in the top of memory. They will
;38 	not be corrupted by the IDE.
;39 
;40 
;41 */
;42 
;43 
;44 #include <stdio.h>
	.debug	I 'D:\Prog\Softools WinIDE\Rabbit 1.68.33\Include\stdio.h' 11 4 11 25 4 25
	.debug	I
;45 #include <rabbit.h>
	.debug	I 'D:\Prog\Softools WinIDE\Rabbit 1.68.33\Include\rabbit.h' 18 23 15 21 3 25
	.debug	I 'D:\Prog\Softools WinIDE\Rabbit 1.68.33\Include\SoftoolsIDblock.h' 28 14 17 9 1 26
	.debug	I
	.debug	I 'D:\Prog\Softools WinIDE\Rabbit 1.68.33\Include\FlashBlock.h' 5 10 15 30 11 24
	.debug	I 'D:\Prog\Softools WinIDE\Rabbit 1.68.33\Include\Flash.h' 5 44 20 14 5 26
	.debug	I
	.debug	I
	.debug	I
;46 #include <string.h>
;47 
	.debug	I 'D:\Prog\Softools WinIDE\Rabbit 1.68.33\Include\string.h' 26 27 13 2 6 25
	.debug	I
;48 #include "..\bb_ram.h"
;49 
	.debug	I 'P:\SHDesigns\SofTools\BB_RAM\bb_ram.h' 29 37 20 23 5 26
	.debug	I
;50 #define FAST_RAM 1	// set to 0 for boards without fast RAM
;51 #define BB_KEY 0xFACE55AAl
;52 
;53 const char test_string[]="This is test to see of data is maintained in BB_R
	.defseg	CONST
	.seg	CONST
_test_string::
	.db	"This is test to see of data is maintained in BB_RAM.",10,0
	.debug	G _test_string 32 0
;54 
;55 #pragma SEG(BSS,BB_BSS)
;56 // all your BB variables go here.
;57 char bb_buffer[2048];
;58 long bb_longs[1500];
;59 unsigned long bb_test;
;60 #pragma SEG(BSS)
;61 
;62 long fr_longs[1500];	// fast RAM data
;63 
;64 unsigned long speed_test(long * buff,unsigned size)
;65 {
	.defseg	FARCODE
	.seg	FARCODE
$speed_test::
	.debug	G $speed_test 33 9
	.debug	{ $speed_test 33 64 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A buff 5 34
	.debug	A size 7 7
;66 	long * tbuff;
	.debug	L tbuff -2 34
;67 	unsigned tsize;
	.debug	L tsize -4 7
;68 	unsigned long stime=getMilliSeconds( );
	.debug	L stime -8 9
	.debug	# 68
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
;69 	for (int i=0;i<500;i++)
@4:
	.debug	< @4 @5
	.debug	L i -10 6
	.debug	# 69
	bool	hl
	ld	l,h
	ld	(ix-10),hl
	.seg	FARCODE
@6:
	ld	hl,(ix-10)
	ld	de,0x81f4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@7
;70 	{
;71 		tbuff=buff;
@9:
	.debug	< @9 @10
	.debug	# 71
	ld	hl,(ix+5)
	ld	(ix-2),hl
;72 		tsize=size;
	.debug	# 72
	ld	hl,(ix+7)
	ld	(ix-4),hl
;73 		while (tsize--)
@11:
	.debug	# 73
	ld	hl,(ix-4)
	dec	hl
	ld	(ix-4),hl
	inc	hl
	bool	hl
	jr	z,@12
;74 		{
;75 			(*tbuff)++;
@13:
	.debug	< @13 @14
	.debug	# 75
	ld	hl,(ix-2)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__linc##
	ld	hl,(ix-2)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;76 			tbuff++;
	.debug	# 76
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	(ix-2),hl
;77 		}
@14:
	.debug	>
;78 	}
	jr	@11
@12:
@10:
	.debug	>
;79 	return getMilliSeconds( )-stime;
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	jr	@6
@7:
@5:
	.debug	>
	.debug	# 79
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
;80 }
@2:
	.debug	} @2 80

@1	equ	10
	ld	sp,ix
	pop	ix
	lret
@3	equ	12
;81 
;82 void displayMBxCR( unsigned cr, unsigned sr )
;83 {
$displayMBxCR::
	.debug	G $displayMBxCR 35 9
	.debug	{ $displayMBxCR 35 82 @17 @16
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A cr 5 7
	.debug	A sr 7 7
;84 static const char ws[] = { 4, 2, 1, 0 };
	.seg	CONST
@18:
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0
	.debug	S ws @18 36
	.seg	FARCODE
;85 
;86 	printf( "  MB%dCR: CS%d/OE%d, WE: %s, %d rd: %d wr wait states.\r\n",
;87 		cr, sr & 3, (srMB0CR & 4) != 0, (sr & 8) == 0 ? "Yes" : "No",
;88 		ws[ sr >> 6 ], ws[ sr >> 6 ] + 1 );
	.debug	# 88
	ld	hl,(ix+7)
	ld	a,0x6
	call	__uishr##
	ld	de,@18
	add	hl,de
	ld	a,(hl)
	inc	a
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+7)
	ld	a,0x6
	call	__uishr##
	ld	de,@18
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+7)
	ld	de,0x8
	and	hl,de
	jr	nz,@19
	ld	hl,@20
	jr	@21
@19:
	ld	hl,@20+4
@21:
	push	hl
	ld	a,(_srMB0CR)
	and	a,4
	jr	z,@23
	ld	a,1
@23:
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+7)
	ld	de,0x3
	and	hl,de
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,@20+7
	push	hl
	lcall	$printf
	add	sp,14
;89 }
@16:
	.debug	} @16 89

@15	equ	0
	pop	ix
	lret
@17	equ	2
;90 
;91 extern char far *_xmemEnd;	// used by mem info
;92 void show_meminfo(void)
;93 {
$show_meminfo::
	.debug	G $show_meminfo 37 9
	.debug	{ $show_meminfo 37 92 @26 @25
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;94 	char *x = (char *) 0xDFFF;
	.debug	L x -2 38
	.debug	# 94
	ld	hl,0xdfff
	ld	(ix-2),hl
	.seg	FARCODE
;95 	printf( "\x1A""\r\n\n\r\nRunning in: %s\r\nMemory Bank Info:\r\n", _inFlas
	.debug	# 95
ld a,(3)
	or	a,a
	jr	z,@27
	ld	hl,@20+64
	jr	@28
@27:
	ld	hl,@20+70
@28:
	push	hl
	ld	hl,@20+74
	push	hl
	lcall	$printf
	add	sp,4
;96 	displayMBxCR( 0, srMB0CR );
	.debug	# 96
	ld	a,(_srMB0CR)
	bool	hl
	ld	l,a
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$displayMBxCR
	add	sp,4
;97 	displayMBxCR( 1, srMB1CR );
	.debug	# 97
	ld	a,(_srMB1CR)
	bool	hl
	ld	l,a
	push	hl
	ld	l,0x1
	push	hl
	lcall	$displayMBxCR
	add	sp,4
;98 	displayMBxCR( 2, srMB2CR );
	.debug	# 98
	ld	a,(_srMB2CR)
	bool	hl
	ld	l,a
	push	hl
	ld	l,0x2
	push	hl
	lcall	$displayMBxCR
	add	sp,4
;99 	displayMBxCR( 3, srMB3CR );
	.debug	# 99
	ld	a,(_srMB3CR)
	bool	hl
	ld	l,a
	push	hl
	ld	l,0x3
	push	hl
	lcall	$displayMBxCR
	add	sp,4
;100 
;101 	printf( "\r\nXmem Info:\r\n" );
	.debug	# 101
	ld	hl,@20+116
	push	hl
	lcall	$printf
	pop	de
;102 	printf( "  Stack end : %lX\r\n", (char far *) x );
	.debug	# 102
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,@20+131
	push	hl
	lcall	$printf
	add	sp,6
;103 	printf( "  Xmem base : %lX\r\n", xalloc( 0 ) );
	.debug	# 103
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$xalloc
	add	sp,4
	push	bc
	push	de
	ld	hl,@20+151
	push	hl
	lcall	$printf
	add	sp,6
;104 	printf( "  Xmem free : %lX (%uk)\r\n", xavail(), xavail() / 1024 );
	.debug	# 104
	lcall	$xavail
	ld	a,0xa
	call	__ulshr##
	push	bc
	push	de
	lcall	$xavail
	push	bc
	push	de
	ld	hl,@20+171
	push	hl
	lcall	$printf
	add	sp,10
;105 	printf( "  Xmem end  : %lX\r\n", _xmemEnd - 1 );
	.debug	# 105
	ld	de,(__xmemEnd)
	ld	bc,(__xmemEnd+2)
	call	__ldec##
	push	bc
	push	de
	ld	hl,@20+197
	push	hl
	lcall	$printf
	add	sp,6
;106 }
@25:
	.debug	} @25 106

@24	equ	2
	ld	sp,ix
	pop	ix
	lret
@26	equ	4
;107 
;108 void main(void)
;109 {
$main::
	.debug	G $main 37 9
	.debug	{ $main 37 108 @32 @31
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
;110 	unsigned long bb_size;
	.debug	L bb_size -4 9
;111 	char far * bb_base;
	.debug	L bb_base -8 39
;112 	char far * bb_array;
	.debug	L bb_array -12 39
;113 	ipset0();
	.debug	# 113
	ipset	0
;114 	WDT_DISABLE();
	.debug	# 114
	ld	l,0x09
	ioi ld	(hl),0x51
	ioi ld	(hl),0x54
;115 	startTimer(10,NULL,1);
	.debug	# 115
	ld	hl,0x1
	push	hl
	ld	l,h
	push	hl
	ld	l,0xa
	push	hl
	lcall	$startTimer
	add	sp,6
;116 #if FAST_RAM
;117 / map upper RAM with lots of waits tates, that way we can
;118 	// tell be the difference in speed
;119     // you do NOT want to do this, this is just for testing!
;120 	outi(MB2CR,srMB2CR&=0x3f);
	.debug	# 120
	ld	a,(_srMB2CR)
	and	a,63
	ld	(_srMB2CR),a
	ioi ld	(22),a
;121 	outi(MB3CR,srMB3CR&=0x3f);
	.debug	# 121
	ld	a,(_srMB3CR)
	and	a,63
	ld	(_srMB3CR),a
	ioi ld	(23),a
;122 #endif
;123 
;124     printf("Startup.\n");
	.debug	# 124
	ld	hl,@20+217
	push	hl
	lcall	$printf
	pop	de
;125 	show_meminfo();
	.debug	# 125
	lcall	$show_meminfo
;126 
;127 #if FAST_RAM
;128  if running in FAST RAM, we need to map the BB_BSS segment.
;129 	bb_size=get_bb_size();	// ask lib size of BB_BSS
	.debug	# 129
	lcall	$get_bb_size
	ex	de,hl
	ld	hl,0
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;130     // assume this works
;131 	bb_base=bb_xalloc(bb_size); // you should see the test string after the fi
	.debug	# 131
	ld	bc,hl
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;132     map_bb_ram(bb_base);  // map DATASEG to BBRAM and STACSEG to fast RAM
	.debug	# 132
	push	bc
	push	de
	lcall	$map_bb_ram
	add	sp,4
;133 #endif
;134 	// allocate a BB_RAM far array
;135     bb_array=bb_xalloc(1234);	// allocate an array in BB_RAM
	.debug	# 135
	ld	de,0x4d2
	ld	bc,0
	push	bc
	push	de
	lcall	$bb_xalloc
	add	sp,4
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;136 	printf("\nbb_Array is at 0x%lX\n",bb_array);
	.debug	# 136
	push	bc
	push	de
	ld	hl,@20+227
	push	hl
	lcall	$printf
	add	sp,6
;137 	// test flasg to see if mem is valid
;138 	if (bb_test!=BB_KEY)
	.debug	# 138
	ld	de,(_bb_test)
	ld	bc,(_bb_test+2)
	push	bc
	push	de
	ld	de,0xaa56
	ld	bc,0x531
	call	__ladd##
	jr	z,@33
;139 	{
;140 		// init variables because flag is invalid
;141 		printf("Key not valid, must be first run, init variables.\n");
@34:
	.debug	< @34 @35
	.debug	# 141
	ld	hl,@20+250
	push	hl
	lcall	$printf
	pop	de
;142 		strcpy(bb_buffer,test_string);
	.debug	# 142
	ld	hl,_test_string
	push	hl
	ld	hl,_bb_buffer
	push	hl
	call	_strcpy
	add	sp,4
;143 		bb_test=BB_KEY;
	.debug	# 143
	ld	de,0x55aa
	ld	bc,0xface
	ld	(_bb_test),de
	ld	(_bb_test+2),bc
;144 	}
@35:
	.debug	>
;145 	else
;146 		printf("Memory key is valid ;)\n");
	jr	@36
@33:
	.debug	# 146
	ld	hl,@20+301
	push	hl
	lcall	$printf
	pop	de
;147 	if (strcmp(bb_buffer,test_string)==0)
@36:
	.debug	# 147
	ld	hl,_test_string
	push	hl
	ld	hl,_bb_buffer
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@37
;148 		printf("Test string is valid.\n");
	.debug	# 148
	ld	hl,@20+325
	push	hl
	lcall	$printf
	pop	de
;149 	else
;150 	{
	jr	@38
@37:
;151 		printf("Test string is corrupted.\n");
@39:
	.debug	< @39 @40
	.debug	# 151
	ld	hl,@20+348
	push	hl
	lcall	$printf
	pop	de
;152 		strcpy(bb_buffer,test_string);
	.debug	# 152
	ld	hl,_test_string
	push	hl
	ld	hl,_bb_buffer
	push	hl
	call	_strcpy
	add	sp,4
;153 	}
@40:
	.debug	>
;154 	// test speed of RAm to see differences
;155 	printf("Speed test of fast RAM:   %ld ms.\n",speed_test(fr_longs, sizeof( 
@38:
	.debug	# 155
	ld	hl,0x5dc
	push	hl
	ld	hl,_fr_longs
	push	hl
	lcall	$speed_test
	add	sp,4
	push	bc
	push	de
	ld	hl,@20+375
	push	hl
	lcall	$printf
	add	sp,6
;156 	printf("Speed test of BB_BSS RAM: %ld ms.\n",speed_test(bb_longs, sizeof( 
	.debug	# 156
	ld	hl,0x5dc
	push	hl
	ld	hl,_bb_longs
	push	hl
	lcall	$speed_test
	add	sp,4
	push	bc
	push	de
	ld	hl,@20+410
	push	hl
	lcall	$printf
	add	sp,6
;157 	while (1)
@41:
	.debug	# 157
;158 	{
;159 
;160 	}
@43:
	.debug	< @43 @44
@44:
	.debug	>
;161 }
	jr	@41
@31:
	.debug	} @31 161

@30	equ	12
	ld	sp,ix
	pop	ix
	lret
@32	equ	14
	.extern	$printf 40
	.extern	_srMB0CR 3
	.extern	_srMB1CR 3
	.extern	_srMB2CR 3
	.extern	_srMB3CR 3
	.extern	__TimerMilliSeconds 41
	.extern	$startTimer 42
	.extern	$xalloc 43
	.extern	$xavail 44
	.extern	_strcmp 45
	.extern	_strcpy 46
	.extern	$map_bb_ram 47
	.extern	$bb_xalloc 43
	.extern	$get_bb_size 48
	.defseg	BB_BSS
	.seg	BB_BSS
_bb_buffer::
	.ds	2048
	.debug	G _bb_buffer 49 0
_bb_longs::
	.ds	6000
	.debug	G _bb_longs 50 0
_bb_test::
	.ds	4
	.debug	G _bb_test 9 0
	.bseg
_fr_longs::
	.ds	6000
	.debug	G _fr_longs 50 0
	.extern	__xmemEnd 39
	.debug	T	0900012000360003003600
	.debug	T	0F00022100020009002200000007000200
	.debug	T	070000220002000800
	.debug	T	0F00022300020001000700000007000200
	.debug	T	0900012400040003000400
	.debug	T	0B000225000100010001000000
	.debug	T	070000260002000300
	.debug	T	070008270004000300
	.debug	T	0F0002280002000600260000000D000000
	.debug	T	0900012900080009000200
	.debug	T	1300022A0003000100070000003300020003000400
	.debug	T	0B00022B000100270009000000
	.debug	T	0B00022C000100090001000000
	.debug	T	0F00022D00020006002600000026000200
	.debug	T	0F00022E00020026002600000026000200
	.debug	T	0B00022F000100010027000000
	.debug	T	0B000230000100070001000000
	.debug	T	0900013100000803000008
	.debug	T	090001320070170800DC05
	.debug	T	070000330002002500
	.seg	CONST
@20:
	.db	"Yes",0,"No",0,"  MB%dCR: CS%d/OE%d, WE: %s, %d rd: %d wr wait states.",13,10,0,"flash",0,"RAM",0,26,13,10,10,13,10,"Runni"
	.db	"ng in: %s",13,10,"Memory Bank Info:",13,10,0,13,10,"Xmem Info:",13,10,0,"  Stack end : %lX",13,10,0,"  Xmem base : %lX",13
	.db	10,0,"  Xmem free : %lX (%uk)",13,10,0,"  Xmem end  : %lX",13,10,0,"Startup.",10,0,10,"bb_Array is at 0x%lX",10,0,"Key "
	.db	"not valid, must be first run, init variables.",10,0,"Memory key is valid ;)",10,0,"Test string is"
	.db	" valid.",10,0,"Test string is corrupted.",10,0,"Speed test of fast RAM:   %ld ms.",10,0,"Speed test of "
	.db	"BB_BSS RAM: %ld ms.",10,0
	.end
